#include <stdio.h>
#include <mpi.h>
#include <unistd.h>

void work(int iter)
{
    sleep(iter);
}

int main(int argc, char **argv)
{
    int rank, nsecs, flag , niter;
	MPI_Request req;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    if (rank == 0)
    {
        nsecs = 10;
        sleep(nsecs);
		MPI_Send(&nsecs,1,MPI_INT,1,1000,MPI_COMM_WORLD);
		

        /* TRAVAIL A FAIRE
           Envoyer nsecs au processus 1
         */
    }
    else if (rank == 1)
    {
        niter = 0;
		MPI_Irecv(&nsecs,1,MPI_INT,0,1000,MPI_COMM_WORLD,&req);
		while(flag == 0){
			MPI_Test(&req,&flag,MPI_STATUS_IGNORE);
			niter++;
			printf("Itération numéro :%d\n",niter);
			work(niter);
		}
		MPI_Wait(&req,MPI_STATUS_IGNORE);
		/* TRAVAIL A FAIRE

           Tant qu'on n'a pas recu nsecs de P0 :
               
               niter++;
               work(niter);
           */

        printf("Nsecs = %d s  / Nb iter = %d\n", nsecs, niter);
    }

    MPI_Finalize();
    return 0;
}

